/*************************************************************************
 *
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 * 
 * Copyright 2008 by Nakata, Maho
 *
 * MPACK - multiple precision arithmetic library
 *
 * This file is part of MPACK.
 *
 * MPACK is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License version 3
 * only, as published by the Free Software Foundation.
 *
 * MPACK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License version 3 for more details
 * (a copy is included in the LICENSE file that accompanied this code).
 *
 * You should have received a copy of the GNU Lesser General Public License
 * version 3 along with MPACK.  If not, see
 * <http://www.gnu.org/licenses/lgpl.html>
 * for a copy of the LGPLv3 License.
 *
 ************************************************************************/

#include <mblas.h>

int
iCamax(int n, mpc_class * cx, int incx)
{
    int imax = 0;
    mpf_class rmax;
    int ix;

    if (n < 1 || incx <= 0)
	return imax;
    if (n == 1)
	return imax + 1;

    ix = 0;
    rmax = RCabs1(cx[0]);
    ix = ix + incx;
    for (int i = 1; i < n; i++) {
	if (RCabs1(cx[ix]) > rmax) {
	    imax = i;
	    rmax = RCabs1(cx[ix]);
	}
	ix = ix + incx;
    }
    return imax + 1;
}
